unit formMain;
(*
	First run this application to register the extension. Close the application
	afterwards.

	Test this application, by double clicking the Test icon in the Windows
	Explorer. It should start the application.

	When double clicking test2 icon, it should replace te text in the edit fields,
	it should not start an other application


	When attaching the test shortcut in an e-mail and opening with outlook,
	the application should load the contents of the link again.

*)


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ShlObj, DdeMan, OleCtnrs, ActiveX, Registry,
  StdCtrls, SixFavorite;

type
  TForm2 = class(TForm)
	Button1: TButton;
	SaveDialog1: TSaveDialog;
	edtMessage: TEdit;
	Label1: TLabel;
	Label2: TLabel;
	edtDesc: TEdit;
	Button2: TButton;
	OpenDialog1: TOpenDialog;
	SixFavorite1: TSixFavorite;
	procedure FormCreate(Sender: TObject);
	procedure Button1Click(Sender: TObject);
	procedure Button2Click(Sender: TObject);
	procedure ShortCutRunner1Execute(Sender: TObject;
	  const Extension: String; lst: TStrings);
  private
//		procedure CheckInstalled;
		procedure CreateShortcut(const fname: String);
  public
	{ Public declarations }
  end;

	procedure ShellLink(sSrc, sDst: String);

var
  Form2: TForm2;


const
	{ dataF2S }
	rsExtension				= '.sxp';
	rsFILE2SHARE			= 'SixCut';
	rsF2SShortName 			= rsFILE2SHARE + '.Shortcut';
	rsF2SShortcut 			= rsFILE2SHARE + ' snelkoppeling';
	rsF2SInstall  			= 'U heeft de FILE2SHARE Verkenner nog niet eerder opgestart.'#13#10'Wilt u een snelkoppeling naar de Verkenner op uw bureaublad plaatsen?';
	rsF2SLink     			= '\FILE2SHARE Verkenner.lnk';
	rsF2SHelpLink			= '\FILE2SHARE Verkenner Handboek.lnk';
	rsSignature				= 'F2SShortcut100';

implementation

{$R *.dfm}

function ApplicationDir: String;
begin
	Result := ExtractFilePath(Application.ExeName);
end;

{
procedure TForm2.CheckInstalled;
var
	reg:    TRegistry;
	dat:    array[0..4] of byte;
	path:   String;
	ask:    Word;
begin
	reg := TRegistry.Create;

	reg.RootKey := HKEY_CLASSES_ROOT;

	if reg.OpenKey(rsExtension,True) then
	begin
		if reg.ValueExists('') then
			reg.DeleteValue('');
		reg.WriteString('',rsF2SShortName);
		reg.CloseKey;
	end;

	if reg.OpenKey(rsF2SShortName,True) then
	begin
		if not reg.ValueExists(rsF2SShortcut) then
		begin
			reg.WriteString('',rsF2SShortcut);
			dat[0] := 0;
			dat[1] := 0;
			dat[2] := 1;
			dat[3] := 0;
			reg.WriteBinaryData('EditFlags',dat,4);
			reg.WriteString('IsShortcut','');
			reg.WriteString('NeverShowExt','');
		end;
		reg.CloseKey;
	end;

	if reg.OpenKey(rsF2SShortName + '\shell\open',true) then
	begin
		if not reg.ValueExists('EditFlags') then
		begin
			dat[0] := 1;
			dat[1] := 0;
			dat[2] := 0;
			dat[3] := 0;
			reg.WriteBinaryData('EditFlags',dat,4);
		end;
		reg.CloseKey;
	end;


	if reg.OpenKey(rsF2SShortName + '\shell\open\command',true) then
	begin
		if reg.ValueExists('') then
			reg.DeleteValue('');
		reg.WriteString('','"' + Application.ExeName + '" "%1"');
		reg.CloseKey;
	end;

	if reg.OpenKey(rsF2SShortName + '\shell\open\ddeexec',true) then
	begin
		if reg.ValueExists('') then
			reg.DeleteValue('');
		reg.WriteString('','%1');
		reg.CloseKey;
	end;

	// Zelfde als name van TDDEserverConv

	if reg.OpenKey(rsF2SShortName + '\shell\open\ddeexec\topic',true) then
	begin
		if reg.ValueExists('') then
			reg.DeleteValue('');
		reg.WriteString('',rsFILE2SHARE);
		reg.CloseKey;
	end;

	 2.2.0.26
	if reg.OpenKey(rsF2SShortName + '\shell\open\ddeexec\IfExec',true) then
	begin
		if reg.ValueExists('') then
			reg.DeleteValue('');
		reg.WriteString('','%1');
		reg.CloseKey;
	end;

	if reg.OpenKey(rsF2SShortName + '\shell\open\ddeexec\Application',true) then
	begin
		if reg.ValueExists('') then
			reg.DeleteValue('');
		reg.WriteString('',ChangeFileExt(ExtractFileName(Application.ExeName),''));
		reg.CloseKey;
	end;

	// Icon voor shortcut (wordt zelf een shortcut overlay overeengezet)

	if reg.OpenKey(rsF2SShortName + '\DefaultIcon',true) then
	begin
		if reg.ValueExists('') then
			reg.DeleteValue('');
		reg.WriteString('','"' + Application.ExeName + '",0');
		reg.CloseKey;
	end;


	// FILE2SHARE pad zetten (kan nu zonder pad worden uitgevooerd)

	reg.RootKey := HKEY_LOCAL_MACHINE;

	if reg.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\' + ExtractFileName(Application.ExeName),true) then
	begin
		if not reg.ValueExists('') then
		begin
			reg.DeleteValue('');
			reg.DeleteValue('Path');
		end;
		reg.WriteString('',Application.ExeName);
		reg.WriteString('Path',ApplicationDir);
		reg.CloseKey;
	end;


	// Startmenu

	reg.RootKey := HKEY_CURRENT_USER;

	path := ShellFolders1['Programs'] + '\' + rsFILE2SHARE;
	if not DirectoryExists(Path) then
	begin
		ForceDirectories(Path);
		ShellLink(Application.ExeName, Path + rsF2SLink);
		ShellLink(ChangeFileExt(Application.ExeName,'.chm'), Path + rsF2SHelpLink);
	end;

	// Algemene shortcut op desktop

	path := ShellFolders1['Desktop'] + rsF2SLink;

	if not FileExists(path) then
	begin
		ask := MessageDlg(rsF2SInstall,mtConfirmation,[mbYes,mbNo],0);

		if ask = mrYes then
			ShellLink(Application.ExeName, path);
	end;
end;
}


function  CreateLink(lpszPathObj: LPCSTR; lpszPathLink: LPSTR; lpszDesc: LPSTR): HRESULT;
var       hRes: HRESULT;
		  psl:  IShellLink;
		  ppf:  IPersistFile;
		  wsz:  PWideChar;
begin
  CoInitialize(NIL);
  hRes:=CoCreateInstance(CLSID_ShellLink, NIL, CLSCTX_INPROC_SERVER, IShellLink, psl);
  if SUCCEEDED(hres) then begin
	psl.SetPath(lpszPathObj);
	psl.SetDescription(lpszDesc);
	hres:=psl.QueryInterface(IPersistFile, ppf);
	if SUCCEEDED(hres) then begin
	  wsz:=AllocMem(2*MAX_PATH);
	  MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, wsz, MAX_PATH);
	  hres:=ppf.Save(wsz, TRUE);
	  FreeMem(wsz, 2*MAX_PATH);
//      ppf.Release;
	end;
//    psl.Release;
  end;
  Result:=hRes;
end;

procedure ShellLink(sSrc, sDst: String);
begin
  CreateLink(PChar(sSrc), PChar(ChangeFileExt(sDst, '.lnk')), PChar(ExtractFileName(ChangeFileExt(sDst, '.lnk'))));
end;


procedure TForm2.FormCreate(Sender: TObject);
begin
	if ParamCount > 0 then
		SixFavorite1.OpenShortCut(ParamStr(1));
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
	if SaveDialog1.Execute then
		CreateShortcut(SaveDialog1.FileName);
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
	if OPenDialog1.Execute then
		SixFavorite1.OpenShortCut(OPenDialog1.FileName);
end;

procedure TForm2.CreateShortcut(const fname: String);
var
	lst: TStringList;
begin
	lst := TStringList.Create;
	lst.Values['Message'] := edtMessage.text;
	lst.Values['Desc']    := edtDesc.text;

	SixFavorite1.CreateShortCut(SaveDialog1.FileName, lst);

	lst.Free;
end;

procedure TForm2.ShortCutRunner1Execute(Sender: TObject;
  const Extension: String; lst: TStrings);
begin
	edtMessage.text := lst.Values['Message'];
	edtDesc.Text    := lst.Values['Desc'];
end;

end.
